let cleanup;
let port;
let isSiteActive = true;
function createPort() {
    port = chrome?.runtime?.connect("lmbjkaapndnojpkfiokmaffcafoccckc", {
        name: `signals-devtool-webpage`,
    });
}
function sendSignals(signals) {
    if (!port)
        return;
    port.postMessage({
        type: "signals",
        data: signals,
    });
}
export function initSignalsDevtool(signals, effect) {
    cleanup?.();
    createPort();
    if (!port)
        return;
    port.onMessage.addListener((message) => {
        if (message.type === "request_signals")
            sendSignals(signals);
    });
    port.onDisconnect.addListener(() => {
        initSignalsDevtool(signals, effect);
    });
    const dispose = effect(() => {
        if (isSiteActive)
            sendSignals(signals);
    });
    const visibilitychange = () => onvisibilitychange(signals, effect);
    document.addEventListener("visibilitychange", visibilitychange);
    cleanup = () => {
        dispose();
        port?.disconnect();
        document.removeEventListener("visibilitychange", visibilitychange);
    };
}
function onvisibilitychange(signals, effect) {
    if (document.visibilityState === "hidden") {
        isSiteActive = false;
        port?.postMessage({
            type: "visibility_change",
            data: {},
        });
        port?.disconnect();
    }
    else {
        isSiteActive = true;
        initSignalsDevtool(signals, effect);
    }
}
